PROGRAM pruebaascii;


/*

 ==========================================================================
  FUNCIONES ASCII_...

  Estas funciones permiten el manejo de texto como ascii. Permite grabar
  y cargar textos en formato ascii. Asi como leer y escribir letras de
  un texto. Tambien existe opciones de corta/pega de textos. Cuando se
  nombre en estas explicaciones de la libreria, el termino de identificador
  de textos, no hay que confundir este termino, por el que es devuelto
  por las funciones write, si no por el que crean las funciones de la
  libreria dll.

 ==========================================================================
  <version>=ascii_version();

  Retorna el numero de version de las funciones de ascii. Esta es la
  version 2. Esta funcion no necesita parametros.

 ==========================================================================
  ascii_load(<nombre fichero>,<offset variable>,<inicio>,<cantidad>);

  Carga lineas de un fichero del disco en formato ASCII. Se necesita el
  nombre del fichero en el disco duro. El offset a la variable que guardara
  los distintos valores de las variables de texto. Tambiven debemos
  indicar el que linea iniciaremos la lectura del fichero, y el numero
  de lineas que queremos leer.

 ==========================================================================
  ascii_save(<nombre fichero>,<texto>,<modo>);

  Graba lineas en formato ASCII en un fichero del disco. Aparte del nombre
  del fichero, debemos indicar el texto a guardar y el modo. Esto modo
  indica la forma de escribir, si esta 0, la linea se aade al fichero, si
  es 1, el fichero se crea de nuevo.

 ==========================================================================
  ascii_free(<identificador texto>);

  Libera la memoria ocupada por una nueva variable de texto creada. Debemos
  indicar el valor de dicha variable de texto, que es devuelto por las
  funciones que crean dichos nuevos textos.

 ==========================================================================
  <nuevo texto>=ascii_dup(<valor ascii>,<cantidad>);

  Crea una nueva variable de texto, con un caracter determinado. Devuelve
  un valor, que sera el identificador del nuevo texto. Debemos indicar
  el valor ascii, con que se rellenara la nueva variable de texto, y la
  cantidad de letras que tendra dicha variable.

 ==========================================================================
  <nuevo texto>=ascii_add(<texto 1>,<texto 2>);

  Suma dos textos, creando una nueva variable de texto. Debemos indicar
  los dos textos a sumar, y la funcion nos devolvera el identificador
  del nuevo texto.

 ==========================================================================
  <nuevo texto>=ascii_copy(<texto>,<inicio>,<longitud>);

  Crea una nueva variable que es un trozo de un texto. Debemos indicar
  el texto inicial, desde que posicion se van empezar a tomar letras, y
  la cantidad de la misma. Todo esto creara un nuevo texto, cuyo
  idenficador, nos devolvera esta funcion, y que sera una copia del
  texto pasado como parametro, a partir de una posicion de inicio, y
  con la longitud determinada.

 ==========================================================================
  ascii_paste(<texto1>,<texto2>,<posicion>);

  Incrusta un texto en otro. Es decir, pega un texto es otro, machacando
  el contenido del texto original. Debemos pasar como parametros los
  dos texto, e indicar en que posicion sera pegado el segundo texto.

 ==========================================================================
  <longitudtexto>=ascii_len(<texto>);

  Devuelve la longitud de un texto. Unicamente debemos pasar el valor que
  identifica al texto que queremos medir. Todos los textos tienen un valor
  que los identifica, que es un valor que indica el offset al texto.

 ==========================================================================
  ascii_setchar(<texto>,<posicion>,<valor ascii>);

  Pone un valor ascii dentro de un texto. Pone una letra, cuyo valor ascii
  debemos indicar como parametro dentro de un texto y en una posicion
  determinada.

 ==========================================================================
  <letra leida>=ascii_getchar(<texto>,<posicion>);

  Lee un valor ascii en una posicion de un texto. Nos devuelve el valor
  ascii de la letra del texto, que este en la posicion que le indiquemos.

 ==========================================================================

  FUNCIONES INPUT_...

  El input, es la posibilidad de introducir datos desde el teclado,
  directamente a una variable. Estas funciones facilitan el uso de input.
  Existen funciones para crear variables especiales de input, para
  introducir un caracter en la nueva variable, y para borrar el ultimo
  caracter introducido. Tambien existe otras dos funciones, una que libera
  la memoria ocupada por la variable, y otra que nos devuelve el numero de
  version de estas funciones. Las funciones se autocorrigen, es decir, no
  hace falta comprobar si estamos al final o al principio de la cadena,
  ya que todas las funciones, nunca escriben datos fuera de sus margenes.

 ==========================================================================
  <version>=input_version();

  Retorna el numero de version de las funciones de input. Esta es la
  version 1. Esta funcion no necesita parametros.

 ==========================================================================
  <nuevo texto>=input_new(<numero de caracteres>);

  Crea una nueva variable de input. Debemos el indicar el numero maximo
  de caracteres que tendra la variable, como parametro. Y la funcion nos
  devolvera una valor, que sera el que utilicemos para referirnos a la
  nueva variable.

 ==========================================================================
  input_free(<identificador input>);

  Libera la memoria ocupada por la variable de input, cuyo identificador
  debemos pasar como parametro. Esta funcion solo sera necesaria cuando se
  este bajo de memoria.

 ==========================================================================
  input_add(<identificador input>,<valor ascii>);

  Aade un valor ascii, que es uno de los parametros, a una variable del
  tipo input, cuyo identificador sera el otro parametro. Si introducimos
  el codigo ascii de borrar, la variable no sera borrada. Y si introducimos
  el valor ascii de la tecla enter, tampoco acabara de introducir la linea.
  En resumen, no se leera ninguna tecla de control, como tal, debiendo
  leerlas antes, de llamar a esta funcion, para un funcionamiento adecuado.
  En los dos casos, se introducira un codigo, con un grafico. Estos
  problemas son faciles de resolver, y para mas informacion, mirar el
  ejemplo que se adjunta.

 ==========================================================================
  input_delete(<identificador input>);

  Borra el ultimo caracter introducido. Unicamente debemos indicar el
  identificador de la variable del tipo input, de la cual queremos borrar.
  Consultar ejemplo de input, para mas informacion, y ver un caso practico.

 ==========================================================================

 -------------------------------------------------------
 -   Si se produce error, las funciones devuelven -1   -
 -------------------------------------------------------

*/

GLOBAL
    texto_input;
    text1="Prueba de texto.";
    text2="Otra linea mas.";
    text3="XXXXXXXXXXXXXXXXX";
    text4="Pegado";
    texto_suma;
    texto_nuevo;
    texto_copiado;
    longitudtexto;
    tablatexto[40];
    valor_ascii;

IMPORT "ascii.dll";

BEGIN

    // Ejemplo de save, se crea un fichero co 20 lineas
    ascii_save("pruebas","Linea 1",1);
    ascii_save("pruebas","Linea 2",0);
    ascii_save("pruebas","Linea 3",0);
    ascii_save("pruebas","Linea 4",0);
    ascii_save("pruebas","Linea 5",0);
    ascii_save("pruebas","Linea 6",0);
    ascii_save("pruebas","Linea 7",0);
    ascii_save("pruebas","Linea 8",0);
    ascii_save("pruebas","Linea 9",0);
    ascii_save("pruebas","Linea 10",0);
    ascii_save("pruebas","Linea 11",0);
    ascii_save("pruebas","Linea 12",0);
    ascii_save("pruebas","Linea 13",0);
    ascii_save("pruebas","Linea 14",0);
    ascii_save("pruebas","Linea 15",0);
    ascii_save("pruebas","Linea 16",0);
    ascii_save("pruebas","Linea 17",0);
    ascii_save("pruebas","Linea 18",0);
    ascii_save("pruebas","Linea 19",0);
    ascii_save("pruebas","Linea 20",0);


    // Ejemplo de load, se cargan 4 textos en tablatexto
    ascii_load("pruebas",&tablatexto,6,4);

    write(0,0,0,0,"Ejemplo de Load y Save:");
    write(0,0,10,0,tablatexto[0]);
    write(0,0,20,0,tablatexto[1]);
    write(0,0,30,0,tablatexto[2]);
    write(0,0,40,0,tablatexto[3]);

    // Suma dos textos...
    texto_suma=ascii_add(text1,text2);
    write(0,0,50,0,"Suma de dos textos:");
    write(0,0,60,0,texto_suma);

    //crea un texto nuevo
    texto_nuevo=ascii_dup(45,12);
    write(0,0,70,0,"Crea un nuevo texto:");
    write(0,0,80,0,texto_nuevo);

    // Mide un texto
    longitudtexto=ascii_len(texto_suma);
    write(0,0,90,0,"Longitud de la suma de textos:");
    write_int(0,0,100,0,&longitudtexto);

    // Copia un texto
    texto_copiado=ascii_copy(text3,5,4);
    write(0,0,110,0,"Haciendo una copia de un texto:");
    write(0,0,120,0,texto_copiado);

    // Pega un texto
    ascii_paste(text3,text4,5);
    write(0,0,130,0,"Haciendo un pegado de un texto:");
    write(0,0,140,0,text3);

    // Pega un texto
    ascii_paste(text3,text4,5);
    write(0,0,130,0,"Haciendo un pegado de un texto:");
    write(0,0,140,0,text3);

    // Leyendo un caracter
    valor_ascii=ascii_getchar(text3,4);
    write(0,0,150,0,"Leyendo un caracter:");
    write_int(0,0,160,0,&valor_ascii);

    // Escribiendo un caracter
    // Leyendo un caracter
    ascii_setchar(text4,4,valor_ascii);
    write(0,0,170,0,"Escribiendo un caracter ascii:");
    write(0,0,180,0,text4);

    LOOP

        IF (key(_esc))
            BREAK;
        END
        FRAME;
    END

    ascii_free(texto_suma);
    ascii_free(texto_nuevo);
    ascii_free(texto_copiado);

    delete_text(all_text);
    let_me_alone();   // Nos quedamos solos..... ;D

    // Inicializando ejemplo de input....
    texto_input=input_new(30);
    write(0,0,0,0,"Introduce un texto:");
    write(0,120,0,0,texto_input);

    LOOP
        IF (scan_code<>_enter)
            // Borra un caracter del input....
            IF (scan_code==_backspace)
                input_delete(texto_input);
                ascii=0;
            ELSE
                // Suma un caracter al input....
                IF (ascii<>0)
                    input_add(texto_input,ascii);
                    ascii=0;
                END
            END
        ELSE
            BREAK;
        END
        FRAME;
    END

    // Libera la memoria del input....
    input_free(texto_input);

END